--- old/usr/src/lib/libdisasm/common/dis_i386.c	2015-10-14 16:45:08.198100314 -0400
+++ new/usr/src/lib/libdisasm/common/dis_i386.c	2015-10-14 16:45:08.201713885 -0400
@@ -184,15 +184,6 @@
 	return (0);
 }
 
-static int
-dis_i386_instrlen(dis_handle_t *dhp, uint64_t pc)
-{
-	if (dis_disassemble(dhp, pc, NULL, 0) != 0)
-		return (-1);
-
-	return (dhp->dh_addr - pc);
-}
-
 dis_arch_t dis_arch_i386 = {
 	.da_supports_flags	= dis_i386_supports_flags,
 	.da_handle_attach	= dis_i386_handle_attach,
@@ -200,5 +191,4 @@
 	.da_disassemble		= dis_i386_disassemble,
 	.da_min_instrlen	= dis_i386_min_instrlen,
 	.da_max_instrlen	= dis_i386_max_instrlen,
-	.da_instrlen		= dis_i386_instrlen,
 };
--- old/usr/src/lib/libdisasm/common/libdisasm.c	2015-10-14 16:45:08.309407639 -0400
+++ new/usr/src/lib/libdisasm/common/libdisasm.c	2015-10-14 16:45:08.313146961 -0400
@@ -272,9 +272,21 @@
 	return (dhp->dh_arch->da_max_instrlen(dhp));
 }
 
+static int
+dis_generic_instrlen(dis_handle_t *dhp, uint64_t pc)
+{
+	if (dis_disassemble(dhp, pc, NULL, 0) != 0)
+		return (-1);
+
+	return (dhp->dh_addr - pc);
+}
+
 int
 dis_instrlen(dis_handle_t *dhp, uint64_t pc)
 {
+	if (dhp->dh_arch->da_instrlen == NULL)
+		return (dis_generic_instrlen(dhp, pc));
+
 	return (dhp->dh_arch->da_instrlen(dhp, pc));
 }
 
